window.addEventListener('load',testStartup,false);

function testStartup() {
	testpanel.init();
}

window.addEventListener('blur',testBlur,false);

function testBlur() {
	try {
		testpanel.panel.hidePopup();
	} catch(e) { }
	window.close();
}

var testpanel = {

	dwin : null, // the xul dialog
	panel: null, // the xul panel

	// the property below determines the type of test to run.
	// left clicking on the panel will cause the top and left
	// properties of the panel to be updated each time the
	// mouse is moved. middle or right clicking on the panel
	// will cause the panel.moveTo() method to be called each
	// time the mouse is moved.
	type: 0,

	offsetX: 0,
	offsetY: 0,

	init: function() {
		this.dwin = document.getElementById('testpanelWin');
		this.panel = document.getElementById('testpanel');
	},

	beginTest: function() {
		var w = window.screen.width;
		var h = window.screen.height;
		var x = parseInt(w / 2) - 250;
		var y = parseInt(h / 2) - 250;

		this.panel.openPopupAtScreen(x,y,false);
	},

	mdown: function(ev) {
		this.type = ev.which;

		var evx = parseInt(ev.screenX);
		var pnlx = parseInt(this.panel.boxObject.screenX);
		var evy = parseInt(ev.screenY);
		var pnly = parseInt(this.panel.boxObject.screenY);

		window.opener.content.status = 'eventX: '+evx+' panelX: '+pnlx;

		this.offsetX = evx - pnlx;
		this.offsetY = evy - pnly;

		window.addEventListener('mousemove',testpanel.mmove,false);
	},

	mmove: function(ev) {
		var x = ev.screenX - testpanel.offsetX;
		var y = ev.screenY - testpanel.offsetY;
		window.opener.content.status = 'eventX: '+ev.screenX+' - offsetX: '+testpanel.offsetX+' = panelX: '+x;

		if (testpanel.type == 1) {
			testpanel.panel.left = x;
			testpanel.panel.top = y;
		} else {
			testpanel.panel.moveTo(x,y);
		}
	},

	mup: function(ev) {
		window.removeEventListener('mousemove',testpanel.mmove,false);
	},

	mover: function(ev) {
		window.focus();
		var ww = parseInt(this.dwin.boxObject.width);
		var wh = parseInt(this.dwin.boxObject.height);
		var wx = parseInt(this.dwin.boxObject.screenX);
		var wy = parseInt(this.dwin.boxObject.screenY);

		var pw = 500;
		var ph = 500;

		var cx = wx + parseInt(ww / 2);
		var cy = wy + parseInt(wh / 2);

		var x = cx - parseInt(pw / 2);
		var y = cy - parseInt(ph / 2);
		this.panel.openPopupAtScreen((x<0) ? 0 : x,(y<0) ? 0 : y,false);
	}
};
